## mingw-w64-openlibm-0.8.2-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25)

project(openlibm
        VERSION 0.8.0
        LANGUAGES C ASM)

add_library("${PROJECT_NAME}" SHARED)


# Find the relevant folder depending on the architecture
set(OPENLIBM_ARCH_FOLDER ${CMAKE_SYSTEM_PROCESSOR})
string(TOLOWER "${OPENLIBM_ARCH_FOLDER}" OPENLIBM_ARCH_FOLDER)

if(${OPENLIBM_ARCH_FOLDER} STREQUAL "amd64" OR ${OPENLIBM_ARCH_FOLDER} STREQUAL "x86_64")
    set(OPENLIBM_ARCH_FOLDER "amd64")
elseif(${OPENLIBM_ARCH_FOLDER} MATCHES "arm64")
    set(OPENLIBM_ARCH_FOLDER "aarch64")
elseif(${OPENLIBM_ARCH_FOLDER} STREQUAL "x86")
    set(OPENLIBM_ARCH_FOLDER "i387")
elseif(${OPENLIBM_ARCH_FOLDER} STREQUAL "powerpc")
    set(OPENLIBM_ARCH_FOLDER "powerpc")
else()
    message(FATAL_ERROR "${PROJECT_NAME} not set up for detected architecture: ${OPENLIBM_ARCH_FOLDER}")
endif()


# Compile flags
list(APPEND C_ASM_COMPILE_FLAGS "-ffp-contract=off" "-fno-fast-math" "-fno-rounding-math" "-fno-math-errno")
list(APPEND C_ASM_COMPILE_FLAGS "-fPIC" "-std=c99" "-fno-builtin")
list(APPEND C_ASM_COMPILE_FLAGS "-Wall" "-Wno-implicit-function-declaration")
list(APPEND C_ASM_COMPILE_FLAGS "-DASSEMBLER" "-D__BSD_VISIBLE" "-O3")

# Compiler-specific compile flags
if("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")
    list(APPEND C_ASM_COMPILE_FLAGS "-fno-strict-aliasing" "-ffp-exception-behavior=strict")
elseif("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
    list(APPEND C_ASM_COMPILE_FLAGS "-fno-gnu89-inline")
else()
    message(FATAL_ERROR "${PROJECT_NAME} not set up to be compiled with ${CMAKE_C_COMPILER_ID}")
endif()

# Architecture-specific compile flags - take advantage of sse on x86
if(${OPENLIBM_ARCH_FOLDER} STREQUAL "i387")
    list(APPEND C_ASM_COMPILE_FLAGS "-march=i686" "-m32" "-msse2" "-mfpmath=sse")
elseif(${OPENLIBM_ARCH_FOLDER} STREQUAL "amd64")
    list(APPEND C_ASM_COMPILE_FLAGS "-m64" "-msse2" "-mfpmath=sse")
endif()

# Suppress warnings if requested
if(OPENLIBM_SUPPRESS_WARNINGS)
    list(APPEND C_ASM_COMPILE_FLAGS "-w")
endif()

list(APPEND C_ASM_COMPILE_FLAGS
        "-I${PROJECT_SRC}"
        "-I${PROJECT_SRC}/include"
        "-I${PROJECT_SRC}/${OPENLIBM_ARCH_FOLDER}"
        "-I${PROJECT_SRC}/src"
)

# Add compile flags
target_compile_options("${PROJECT_NAME}" PUBLIC ${C_ASM_COMPILE_FLAGS})


# Determine if long double and double is the same on current platform
if(${OPENLIBM_ARCH_FOLDER} STREQUAL "i387" OR ${OPENLIBM_ARCH_FOLDER} STREQUAL "amd64")
    set(LONG_DOUBLE_NOT_DOUBLE 1)
elseif(${OPENLIBM_ARCH_FOLDER} STREQUAL "aarch64")
    if(NOT (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin" OR ${CMAKE_SYSTEM_NAME} STREQUAL "Windows"))
        set(LONG_DOUBLE_NOT_DOUBLE 1)
    endif()
endif()

# Project Source
set(PROJECT_SRC "${PROJECT_SOURCE_DIR}")

# Common
list(APPEND OPENLIBM_C_SOURCE
        # src
        "${PROJECT_SRC}/src/common.c"
        "${PROJECT_SRC}/src/e_acos.c"
        "${PROJECT_SRC}/src/e_acosf.c"
        "${PROJECT_SRC}/src/e_acosh.c"
        "${PROJECT_SRC}/src/e_acoshf.c"
        "${PROJECT_SRC}/src/e_asin.c"
        "${PROJECT_SRC}/src/e_asinf.c"
        "${PROJECT_SRC}/src/e_atan2.c"
        "${PROJECT_SRC}/src/e_atan2f.c"
        "${PROJECT_SRC}/src/e_atanh.c"
        "${PROJECT_SRC}/src/e_atanhf.c"
        "${PROJECT_SRC}/src/e_cosh.c"
        "${PROJECT_SRC}/src/e_coshf.c"
        "${PROJECT_SRC}/src/e_exp.c"
        "${PROJECT_SRC}/src/e_expf.c"
        "${PROJECT_SRC}/src/e_fmod.c"
        "${PROJECT_SRC}/src/e_fmodf.c"
        "${PROJECT_SRC}/src/e_hypot.c"
        "${PROJECT_SRC}/src/e_hypotf.c"
        "${PROJECT_SRC}/src/e_j0.c"
        "${PROJECT_SRC}/src/e_j0f.c"
        "${PROJECT_SRC}/src/e_j1.c"
        "${PROJECT_SRC}/src/e_j1f.c"
        "${PROJECT_SRC}/src/e_jn.c"
        "${PROJECT_SRC}/src/e_jnf.c"
        "${PROJECT_SRC}/src/e_lgamma.c"
        "${PROJECT_SRC}/src/e_lgamma_r.c"
        "${PROJECT_SRC}/src/e_lgammaf.c"
        "${PROJECT_SRC}/src/e_lgammaf_r.c"
        "${PROJECT_SRC}/src/e_log.c"
        "${PROJECT_SRC}/src/e_log10.c"
        "${PROJECT_SRC}/src/e_log10f.c"
        "${PROJECT_SRC}/src/e_log2.c"
        "${PROJECT_SRC}/src/e_log2f.c"
        "${PROJECT_SRC}/src/e_logf.c"
        "${PROJECT_SRC}/src/e_pow.c"
        "${PROJECT_SRC}/src/e_powf.c"
        "${PROJECT_SRC}/src/e_remainder.c"
        "${PROJECT_SRC}/src/e_remainderf.c"
        "${PROJECT_SRC}/src/e_rem_pio2.c"
        "${PROJECT_SRC}/src/e_rem_pio2f.c"
        "${PROJECT_SRC}/src/e_sinh.c"
        "${PROJECT_SRC}/src/e_sinhf.c"
        "${PROJECT_SRC}/src/e_sqrt.c"
        "${PROJECT_SRC}/src/e_sqrtf.c"
        "${PROJECT_SRC}/src/k_cos.c"
        "${PROJECT_SRC}/src/k_exp.c"
        "${PROJECT_SRC}/src/k_expf.c"
        "${PROJECT_SRC}/src/k_rem_pio2.c"
        "${PROJECT_SRC}/src/k_sin.c"
        "${PROJECT_SRC}/src/k_tan.c"
        "${PROJECT_SRC}/src/k_cosf.c"
        "${PROJECT_SRC}/src/k_sinf.c"
        "${PROJECT_SRC}/src/k_tanf.c"
        "${PROJECT_SRC}/src/s_asinh.c"
        "${PROJECT_SRC}/src/s_asinhf.c"
        "${PROJECT_SRC}/src/s_atan.c"
        "${PROJECT_SRC}/src/s_atanf.c"
        "${PROJECT_SRC}/src/s_carg.c"
        "${PROJECT_SRC}/src/s_cargf.c"
        "${PROJECT_SRC}/src/s_cbrt.c"
        "${PROJECT_SRC}/src/s_cbrtf.c"
        "${PROJECT_SRC}/src/s_ceil.c"
        "${PROJECT_SRC}/src/s_ceilf.c"
        "${PROJECT_SRC}/src/s_copysign.c"
        "${PROJECT_SRC}/src/s_copysignf.c"
        "${PROJECT_SRC}/src/s_cos.c"
        "${PROJECT_SRC}/src/s_cosf.c"
        "${PROJECT_SRC}/src/s_csqrt.c"
        "${PROJECT_SRC}/src/s_csqrtf.c"
        "${PROJECT_SRC}/src/s_erf.c"
        "${PROJECT_SRC}/src/s_erff.c"
        "${PROJECT_SRC}/src/s_exp2.c"
        "${PROJECT_SRC}/src/s_exp2f.c"
        "${PROJECT_SRC}/src/s_expm1.c"
        "${PROJECT_SRC}/src/s_expm1f.c"
        "${PROJECT_SRC}/src/s_fabs.c"
        "${PROJECT_SRC}/src/s_fabsf.c"
        "${PROJECT_SRC}/src/s_fdim.c"
        "${PROJECT_SRC}/src/s_floor.c"
        "${PROJECT_SRC}/src/s_floorf.c"
        "${PROJECT_SRC}/src/s_fmax.c"
        "${PROJECT_SRC}/src/s_fmaxf.c"
        "${PROJECT_SRC}/src/s_fmin.c"
        "${PROJECT_SRC}/src/s_fminf.c"
        "${PROJECT_SRC}/src/s_fpclassify.c"
        "${PROJECT_SRC}/src/s_frexp.c"
        "${PROJECT_SRC}/src/s_frexpf.c"
        "${PROJECT_SRC}/src/s_ilogb.c"
        "${PROJECT_SRC}/src/s_ilogbf.c"
        "${PROJECT_SRC}/src/s_isinf.c"
        "${PROJECT_SRC}/src/s_isfinite.c"
        "${PROJECT_SRC}/src/s_isnormal.c"
        "${PROJECT_SRC}/src/s_isnan.c"
        "${PROJECT_SRC}/src/s_log1p.c"
        "${PROJECT_SRC}/src/s_log1pf.c"
        "${PROJECT_SRC}/src/s_logb.c"
        "${PROJECT_SRC}/src/s_logbf.c"
        "${PROJECT_SRC}/src/s_modf.c"
        "${PROJECT_SRC}/src/s_modff.c"
        "${PROJECT_SRC}/src/s_nextafter.c"
        "${PROJECT_SRC}/src/s_nextafterf.c"
        "${PROJECT_SRC}/src/s_nexttowardf.c"
        "${PROJECT_SRC}/src/s_remquo.c"
        "${PROJECT_SRC}/src/s_remquof.c"
        "${PROJECT_SRC}/src/s_rint.c"
        "${PROJECT_SRC}/src/s_rintf.c"
        "${PROJECT_SRC}/src/s_round.c"
        "${PROJECT_SRC}/src/s_roundf.c"
        "${PROJECT_SRC}/src/s_scalbln.c"
        "${PROJECT_SRC}/src/s_scalbn.c"
        "${PROJECT_SRC}/src/s_scalbnf.c"
        "${PROJECT_SRC}/src/s_signbit.c"
        "${PROJECT_SRC}/src/s_signgam.c"
        "${PROJECT_SRC}/src/s_sin.c"
        "${PROJECT_SRC}/src/s_sincos.c"
        "${PROJECT_SRC}/src/s_sinf.c"
        "${PROJECT_SRC}/src/s_sincosf.c"
        "${PROJECT_SRC}/src/s_tan.c"
        "${PROJECT_SRC}/src/s_tanf.c"
        "${PROJECT_SRC}/src/s_tanh.c"
        "${PROJECT_SRC}/src/s_tanhf.c"
        "${PROJECT_SRC}/src/s_tgammaf.c"
        "${PROJECT_SRC}/src/s_trunc.c"
        "${PROJECT_SRC}/src/s_truncf.c"
        "${PROJECT_SRC}/src/s_cpow.c"
        "${PROJECT_SRC}/src/s_cpowf.c"
        "${PROJECT_SRC}/src/w_cabs.c"
        "${PROJECT_SRC}/src/w_cabsf.c"

        "${PROJECT_SRC}/src/s_fma.c"
        "${PROJECT_SRC}/src/s_fmaf.c"
        "${PROJECT_SRC}/src/s_lrint.c"
        "${PROJECT_SRC}/src/s_lrintf.c"
        "${PROJECT_SRC}/src/s_lround.c"
        "${PROJECT_SRC}/src/s_lroundf.c"
        "${PROJECT_SRC}/src/s_llrint.c"
        "${PROJECT_SRC}/src/s_llrintf.c"
        "${PROJECT_SRC}/src/s_llround.c"
        "${PROJECT_SRC}/src/s_llroundf.c"
        "${PROJECT_SRC}/src/s_nearbyint.c"

        # C99 complex functions
        "${PROJECT_SRC}/src/s_ccosh.c"
        "${PROJECT_SRC}/src/s_ccoshf.c"
        "${PROJECT_SRC}/src/s_cexp.c"
        "${PROJECT_SRC}/src/s_cexpf.c"
	    "${PROJECT_SRC}/src/s_cimag.c"
        "${PROJECT_SRC}/src/s_cimagf.c"
        "${PROJECT_SRC}/src/s_conj.c"
        "${PROJECT_SRC}/src/s_conjf.c"
	    "${PROJECT_SRC}/src/s_cproj.c"
        "${PROJECT_SRC}/src/s_cprojf.c"
        "${PROJECT_SRC}/src/s_creal.c"
        "${PROJECT_SRC}/src/s_crealf.c"
	    "${PROJECT_SRC}/src/s_csinh.c"
        "${PROJECT_SRC}/src/s_csinhf.c"
        "${PROJECT_SRC}/src/s_ctanh.c"
        "${PROJECT_SRC}/src/s_ctanhf.c"
        "${PROJECT_SRC}/src/s_cacos.c"
        "${PROJECT_SRC}/src/s_cacosf.c"
        "${PROJECT_SRC}/src/s_cacosh.c"
        "${PROJECT_SRC}/src/s_cacoshf.c"
        "${PROJECT_SRC}/src/s_casin.c"
        "${PROJECT_SRC}/src/s_casinf.c"
        "${PROJECT_SRC}/src/s_casinh.c"
        "${PROJECT_SRC}/src/s_casinhf.c"
        "${PROJECT_SRC}/src/s_catan.c"
        "${PROJECT_SRC}/src/s_catanf.c"
        "${PROJECT_SRC}/src/s_catanh.c"
        "${PROJECT_SRC}/src/s_catanhf.c"
        "${PROJECT_SRC}/src/s_clog.c"
        "${PROJECT_SRC}/src/s_clogf.c"

        # bsdsrc
		"${PROJECT_SRC}/bsdsrc/b_exp.c"
		"${PROJECT_SRC}/bsdsrc/b_log.c"
		"${PROJECT_SRC}/bsdsrc/b_tgamma.c"
)

if(NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    list(APPEND OPENLIBM_C_SOURCE
            "${PROJECT_SRC}/src/s_nan.c"
    )
endif()

# Add in long double functions for x86, x64 and aarch64
if(LONG_DOUBLE_NOT_DOUBLE)
    list(APPEND OPENLIBM_C_SOURCE
            "${PROJECT_SRC}/src/s_copysignl.c"
            "${PROJECT_SRC}/src/s_fabsl.c"
            "${PROJECT_SRC}/src/s_llrintl.c"
            "${PROJECT_SRC}/src/s_lrintl.c"
            "${PROJECT_SRC}/src/s_modfl.c"

            "${PROJECT_SRC}/src/e_acosl.c"
            "${PROJECT_SRC}/src/e_asinl.c"
            "${PROJECT_SRC}/src/e_atan2l.c"
            "${PROJECT_SRC}/src/e_fmodl.c"
	        "${PROJECT_SRC}/src/s_fmaxl.c"
            "${PROJECT_SRC}/src/s_fminl.c"
            "${PROJECT_SRC}/src/s_ilogbl.c"
	        "${PROJECT_SRC}/src/e_hypotl.c"
            "${PROJECT_SRC}/src/e_lgammal.c"
            "${PROJECT_SRC}/src/e_remainderl.c"
            "${PROJECT_SRC}/src/e_sqrtl.c"
	        "${PROJECT_SRC}/src/s_atanl.c"
            "${PROJECT_SRC}/src/s_ceill.c"
            "${PROJECT_SRC}/src/s_cosl.c"
            "${PROJECT_SRC}/src/s_cprojl.c"
	        "${PROJECT_SRC}/src/s_csqrtl.c"
            "${PROJECT_SRC}/src/s_floorl.c"
            "${PROJECT_SRC}/src/s_fmal.c"
	        "${PROJECT_SRC}/src/s_frexpl.c"
            "${PROJECT_SRC}/src/s_logbl.c"
            "${PROJECT_SRC}/src/s_nexttoward.c"
	        "${PROJECT_SRC}/src/s_remquol.c"
            "${PROJECT_SRC}/src/s_roundl.c"
            "${PROJECT_SRC}/src/s_lroundl.c"
            "${PROJECT_SRC}/src/s_llroundl.c"
	        "${PROJECT_SRC}/src/s_cpowl.c"
            "${PROJECT_SRC}/src/s_cargl.c"
	        "${PROJECT_SRC}/src/s_sinl.c"
            "${PROJECT_SRC}/src/s_sincosl.c"
            "${PROJECT_SRC}/src/s_tanl.c"
            "${PROJECT_SRC}/src/s_truncl.c"
            "${PROJECT_SRC}/src/w_cabsl.c"
	        "${PROJECT_SRC}/src/s_nextafterl.c"
            "${PROJECT_SRC}/src/s_rintl.c"
            "${PROJECT_SRC}/src/s_scalbnl.c"
            "${PROJECT_SRC}/src/polevll.c"
	        "${PROJECT_SRC}/src/s_casinl.c"
            "${PROJECT_SRC}/src/s_ctanl.c"
	        "${PROJECT_SRC}/src/s_cimagl.c"
            "${PROJECT_SRC}/src/s_conjl.c"
            "${PROJECT_SRC}/src/s_creall.c"
            "${PROJECT_SRC}/src/s_cacoshl.c"
            "${PROJECT_SRC}/src/s_catanhl.c"
            "${PROJECT_SRC}/src/s_casinhl.c"

=== Makefile ===
OPENLIBM_HOME=$(abspath .)
include ./Make.inc

SUBDIRS = src $(ARCH) bsdsrc
ifeq ($(LONG_DOUBLE_NOT_DOUBLE),1)
# Add ld80 directory on x86 and x64
ifneq ($(filter $(ARCH),i387 amd64),)
SUBDIRS += ld80
else
ifneq ($(filter $(ARCH),aarch64),)
SUBDIRS += ld128
else
endif
endif
endif

define INC_template
TEST=test
override CUR_SRCS = $(1)_SRCS
include $(1)/Make.files
SRCS += $$(addprefix $(1)/,$$($(1)_SRCS))
endef

DIR=test

$(foreach dir,$(SUBDIRS),$(eval $(call INC_template,$(dir))))

DUPLICATE_NAMES = $(filter $(patsubst %.S,%,$($(ARCH)_SRCS)),$(patsubst %.c,%,$(src_SRCS)))
DUPLICATE_SRCS = $(addsuffix .c,$(DUPLICATE_NAMES))

OBJS =  $(patsubst %.f,%.f.o,\
	$(patsubst %.S,%.S.o,\
	$(patsubst %.c,%.c.o,$(filter-out $(addprefix src/,$(DUPLICATE_SRCS)),$(SRCS)))))

# If we're on windows, don't do versioned shared libraries. Also, generate an import library
# for the DLL. If we're on OSX, put the version number before the .dylib.  Otherwise,
# put it after.
ifeq ($(OS), WINNT)
OLM_MAJOR_MINOR_SHLIB_EXT := $(SHLIB_EXT)
LDFLAGS_add += -Wl,--out-implib,libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT).a
else
ifeq ($(OS), Darwin)
OLM_MAJOR_MINOR_SHLIB_EXT := $(SOMAJOR).$(SOMINOR).$(SHLIB_EXT)
OLM_MAJOR_SHLIB_EXT := $(SOMAJOR).$(SHLIB_EXT)
else
OLM_MAJOR_MINOR_SHLIB_EXT := $(SHLIB_EXT).$(SOMAJOR).$(SOMINOR)
OLM_MAJOR_SHLIB_EXT := $(SHLIB_EXT).$(SOMAJOR)
endif
LDFLAGS_add += -Wl,$(SONAME_FLAG),libopenlibm.$(OLM_MAJOR_SHLIB_EXT)
endif

.PHONY: all check test clean distclean \
	install install-static install-shared install-pkgconfig install-headers


OLM_LIBS := libopenlibm.a
ifneq ($(ARCH), wasm32)
OLM_LIBS += libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT)
endif

all : $(OLM_LIBS)

check test: test/test-double test/test-float
	test/test-double
	test/test-float

libopenlibm.a: $(OBJS)
	$(AR) -rcs libopenlibm.a $(OBJS)

libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT): $(OBJS)
	$(CC) -shared $(OBJS) $(LDFLAGS) $(LDFLAGS_add) -o $@
ifneq ($(OS),WINNT)
	ln -sf $@ libopenlibm.$(OLM_MAJOR_SHLIB_EXT)
	ln -sf $@ libopenlibm.$(SHLIB_EXT)
endif

test/test-double: libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT)
	$(MAKE) -C test test-double

test/test-float: libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT)
	$(MAKE) -C test test-float

COVERAGE_DIR:=cov-html
COVERAGE_FILE:=$(COVERAGE_DIR)/libopenlibm.info
# Gen cov report with:  make clean && make coverage -j
coverage: clean-coverage
	mkdir $(COVERAGE_DIR)
	$(MAKE) test  CODE_COVERAGE=1
	lcov -d amd64 -d bsdsrc -d ld80 -d src \
		--rc lcov_branch_coverage=1 --capture --output-file $(COVERAGE_FILE)
	genhtml --legend --branch-coverage \
		--title "Openlibm commit `git rev-parse HEAD`" \
		--output-directory $(COVERAGE_DIR)/ \
		$(COVERAGE_FILE)

# Zero coverage statistics and Delete report
clean-coverage:
	-lcov -d amd64 -d bsdsrc -d ld80 -d src --zerocounters
	rm -f ./*/*.gcda
	rm -rf $(COVERAGE_DIR)/

clean: clean-coverage
	rm -f aarch64/*.o amd64/*.o arm/*.o bsdsrc/*.o i387/*.o loongarch64/*.o ld80/*.o ld128/*.o src/*.o powerpc/*.o mips/*.o s390/*.o riscv64/*.o
	rm -f libopenlibm.a libopenlibm.*$(SHLIB_EXT)*
	rm -f ./*/*.gcno
	$(MAKE) -C test clean

openlibm.pc: openlibm.pc.in Make.inc Makefile
	echo "version=${VERSION}" > openlibm.pc
	echo "libdir=$(DESTDIR)$(libdir)" >> openlibm.pc
	echo "includedir=$(DESTDIR)$(includedir)/openlibm" >> openlibm.pc
	cat openlibm.pc.in >> openlibm.pc

install-static: libopenlibm.a
	mkdir -p $(DESTDIR)$(libdir)
	cp -RpP -f libopenlibm.a $(DESTDIR)$(libdir)/

install-shared: libopenlibm.$(OLM_MAJOR_MINOR_SHLIB_EXT)
	mkdir -p $(DESTDIR)$(shlibdir)
ifeq ($(OS), WINNT)
	mkdir -p $(DESTDIR)$(libdir)
	cp -RpP -f libopenlibm.*$(SHLIB_EXT) $(DESTDIR)$(shlibdir)/
	cp -RpP -f libopenlibm.*$(SHLIB_EXT).a $(DESTDIR)$(libdir)/
else
	cp -RpP -f libopenlibm.*$(SHLIB_EXT)* $(DESTDIR)$(shlibdir)/
endif

install-pkgconfig: openlibm.pc
	mkdir -p $(DESTDIR)$(pkgconfigdir)
	cp -RpP -f openlibm.pc $(DESTDIR)$(pkgconfigdir)/

install-headers:
	mkdir -p $(DESTDIR)$(includedir)/openlibm
	cp -RpP -f include/*.h $(DESTDIR)$(includedir)/openlibm
	cp -RpP -f src/*.h $(DESTDIR)$(includedir)/openlibm

install: install-static install-shared install-pkgconfig install-headers

=== test/Makefile ===
OPENLIBM_HOME=$(abspath ..)
include ../Make.inc

# Set rpath of tests to builddir for loading shared library
OPENLIBM_LIB = -L.. -lopenlibm
ifneq ($(OS),WINNT)
ifneq ($(OS),Darwin)
OPENLIBM_LIB += -Wl,-rpath=$(OPENLIBM_HOME)
endif
else # WINNT
CFLAGS_add += -DIMPORT_EXPORTS
endif

all: test-double test-float # test-double-system test-float-system

bench: bench-syslibm bench-openlibm

test-double: test-double.c libm-test.c libm-test-ulps.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add) $(LDFLAGS) $(LDFLAGS_arch) $@.c -D__BSD_VISIBLE -I ../include -I../src $(OPENLIBM_LIB) -o $@

test-float: test-float.c libm-test.c libm-test-ulps.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add) $(LDFLAGS) $(LDFLAGS_arch) $@.c -D__BSD_VISIBLE -I ../include -I../src $(OPENLIBM_LIB) -o $@

test-double-system: test-double.c libm-test.c libm-test-ulps.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add) $(LDFLAGS) $(LDFLAGS_arch) $< -DSYS_MATH_H -lm -o $@

test-float-system: test-float.c libm-test.c libm-test-ulps.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add) $(LDFLAGS) $(LDFLAGS_arch) $< -DSYS_MATH_H -lm -o $@

bench-openlibm: libm-bench.cpp
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add) $(LDFLAGS) $(LDFLAGS_arch) $< $(OPENLIBM_LIB) -o $@

bench-syslibm: libm-bench.cpp
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CFLAGS_add) $(LDFLAGS) $(LDFLAGS_arch) $< -lm -o $@

clean:
	rm -fr test-double test-float test-double-system test-float-system bench-openlibm bench-syslibm *.dSYM

=== PKGBUILD ===
# Maintainer: Peter Budai <peterbud@hotmail.com>

_realname=openlibm
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.8.2
pkgrel=1
pkgdesc="High quality system independent, portable, open source libm implementation (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32' 'clangarm64')
msys2_repository_url='https://github.com/JuliaMath/openlibm'
url='https://openlibm.org'
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc")
source=("${_realname}-${pkgver}.tar.gz::https://github.com/JuliaMath/${_realname}/archive/v${pkgver}.tar.gz"
        "0001-openlibm-fix-pkgconfig-file.patch")
sha256sums=('7244f9aa468584744e260cef740d57d10eab6e9c05f62084f8f2ba457f4b4b1d'
            'e3f2974f26d1ea5b548b153408959f3f53ab5d920dec6b94fb69e75654a635f7')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

del_file_exists() {
  for _fname in "$@"
  do
    if [ -f $_fname ]; then
      rm -rf $_fname
    fi
  done
}
# =========================================== #

prepare() {
  cd ${srcdir}/${_realname}-${pkgver}

  apply_patch_with_msg \
    0001-openlibm-fix-pkgconfig-file.patch
}

build() {
  cp -rf "${_realname}-${pkgver}" "build-${MSYSTEM}"

  cd "${srcdir}/build-${MSYSTEM}"
  local _compilersetting="USEGCC=1"
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _compilersetting="USECLANG=1 USEGCC=0"
  fi

  make prefix=${MINGW_PREFIX} ${_compilersetting}
}

check() {
  local _compilersetting="USEGCC=1"
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _compilersetting="USECLANG=1 USEGCC=0"
  fi

  cd "${srcdir}"/build-${MSYSTEM}
  make test ${_compilersetting}
}

package() {
  local _compilersetting="USEGCC=1"
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _compilersetting="USECLANG=1 USEGCC=0"
  fi

  cd "${srcdir}"/build-${MSYSTEM}
  make prefix=${MINGW_PREFIX} DESTDIR="${pkgdir}" install ${_compilersetting}

  install -Dm644 ${srcdir}/build-${MSYSTEM}/LICENSE.md ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
